from vec import Vec2


class Path:
    def __init__(self, points: list[Vec2], extra_data: list):
        self.points: list[Vec2] = points
        self.extra_data = extra_data
        self.normals: list[Vec2] = []
        self._init_normals()

    def _init_normals(self) -> None:
        pt0 = self.points[0]
        self.normals.append(Vec2(pt0.y, -pt0.x))
        for i in range(1, len(self.points) - 1):
            pt1 = self.points[i-1]
            pt2 = self.points[i]
            pt3 = self.points[i+1]
            d1 = (pt1 - pt2).normalized()
            d2 = (pt3 - pt2).normalized()

            d = (d1 + d2).normalized()

            if d2.cross(d) < 0:
                d = -d

            self.normals.append(d)

        ptl = self.points[-1]
        self.normals.append(Vec2(ptl.y, -ptl.x))